# generated by wxGlade 0.3 on Fri Aug 29 21:00:02 2003
"""
/***************************************************************************
                           imgSeekLite - MainForm
                             -------------------
    begin                : 03/08/30 13:35:29 rnc
    Time-stamp:            <03/09/01 08:40:41 rnc>    
    copyright            : (C) 2002 by Ricardo Niederberger Cabral
    email                : nieder|at|mail.ru

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ***************************************************************************/
"""

from wxPython.wx import *
from previewDlg import previewDlg
from sketchDialog import sketchDialog
from imgSeekLiteLib import __version__
import os
from ImgDB import ImgDB

# begin wxGlade: dependencies
# end wxGlade

class MainFrame(wxFrame):
    def __init__(self, *args, **kwds):
        import sys        
        #### guess imgSeekLiteLib data dir
        self.imgseekdatadir = "/usr/share/imgSeekLite/"
        if os.name not in ["nt","dos"]:
            self.imgseekdatadir = sys.exec_prefix + "/share/imgSeekLite/"
            if not os.path.exists(self.imgseekdatadir):
                self.imgseekdatadir = sys.exec_prefix+"/share/imgSeekLite/"
            if not os.path.exists(self.imgseekdatadir):
                self.imgseekdatadir = sys.exec_prefix+"/share/imgSeekLiteLib/"
            if not os.path.exists(self.imgseekdatadir):
                self.imgseekdatadir = sys.exec_prefix+"/imgSeekLiteLib/"
            if not os.path.exists(self.imgseekdatadir):
                print "[Error] Unable to detect imgSeekLiteLib data directory. Make sure imgSeek was installed properly, and report your linux distribution and installation method to nieder at mail dot ru"
                self.imgseekdatadir = sys.exec_prefix+"/share/imgSeekLite/" # get back to default value
        else:
            self.imgseekdatadir = sys.path[0] + "\\share\\imgSeekLite\\"
            
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxFrame.__init__(self, *args, **kwds)
        self.mNotebook = wxNotebook(self, -1, style=0)
        self.browsePane = wxPanel(self.mNotebook, -1)
        self.searchPane = wxPanel(self.mNotebook, -1)
        
        # Menu Bar
        self.mMenuBar = wxMenuBar()
        self.SetMenuBar(self.mMenuBar)
        global ID_CNEW; ID_CNEW = wxNewId()
        global ID_COPEN; ID_COPEN = wxNewId()
        global ID_CSAVE; ID_CSAVE = wxNewId()
        global ID_CRANDOM; ID_CRANDOM = wxNewId()
        global ID_CEXIT; ID_CEXIT = wxNewId()
        global ID_SQUERY; ID_SQUERY = wxNewId()
        global ID_ABOUT; ID_ABOUT = wxNewId()
        wxglade_tmp_menu = wxMenu()
        wxglade_tmp_menu.Append(ID_CNEW, _("&New\tCtrl+N"), _("Discard current collection and start a new one"), wxITEM_NORMAL)
        wxglade_tmp_menu.Append(ID_COPEN, _("&Open\tCtrl+O"), "", wxITEM_NORMAL)
        wxglade_tmp_menu.Append(ID_CSAVE, _("&Save\tCtrl+S"), "", wxITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(ID_CRANDOM, _("Show random images"), "", wxITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(ID_CEXIT, _("E&xit\tCtrl+X"), "", wxITEM_NORMAL)
        self.mMenuBar.Append(wxglade_tmp_menu, _("&Collection"))
        wxglade_tmp_menu = wxMenu()
        wxglade_tmp_menu.Append(ID_SQUERY, _("Show sketch window"), "", wxITEM_NORMAL)
        self.mMenuBar.Append(wxglade_tmp_menu, _("&Sketch"))
        wxglade_tmp_menu = wxMenu()
        wxglade_tmp_menu.Append(ID_ABOUT, _("About ..."), "", wxITEM_NORMAL)
        self.mMenuBar.Append(wxglade_tmp_menu, _("&About"))
        # Menu Bar end
        self.mStatusBar = self.CreateStatusBar(2)
        self.thumbList = wxListCtrl(self.searchPane, -1, style=wxLC_ICON|wxLC_NO_HEADER|wxLC_SINGLE_SEL|wxLC_SORT_DESCENDING|wxSUNKEN_BORDER)
        self.dirTree = wxGenericDirCtrl(self.browsePane, -1)
        self.recursiveCheck = wxCheckBox(self.browsePane, -1, _("Recursively"))
        self.addDirBtn = wxBitmapButton(self.browsePane, -1, wxBitmap(self.imgseekdatadir+"wizard.png", wxBITMAP_TYPE_ANY))

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

        ### Private vars
        self.mPreviewDlg = None
        self.mSketchDlg = None        
        self.previewBmpCtrl = None
        
        ### Events        
        EVT_BUTTON (self, self.addDirBtn.GetId(), self.onAddDir)
        EVT_LIST_ITEM_SELECTED(self, self.thumbList.GetId(), self.onThumbSelected)
        EVT_LIST_ITEM_RIGHT_CLICK(self, self.thumbList.GetId(), self.onThumbActivated)        
                
        ### Menus
        # Collection
        EVT_MENU(self, ID_CNEW , self.onNewDB)
        EVT_MENU(self, ID_COPEN , self.onOpenDB)
        EVT_MENU(self, ID_CSAVE , self.onSaveDB)
        EVT_MENU(self, ID_CRANDOM , self.populateThumbRandom)
        EVT_MENU(self, ID_CEXIT , self.onExitMenu)
        # Sketch
        EVT_MENU(self, ID_SQUERY , self.onShowSketch)
        # About
        EVT_MENU(self, ID_ABOUT , self.onAboutMenu)

        ### Settings
        
        ### Other
        self.onShowSketch(None)
        
        ### Open Image Databasey
        udir = self.makeUserDataDir()
        self.imgdb = ImgDB(udir + "data.img")
        self.updateStatus()
        self.populateThumbRandom(20)

    def makeUserDataDir(self):
        thdir = os.path.expanduser(os.path.join("~",".imgSeekLite","")) # path for storing thumbnails. Calculate it only once here.
        # just to make sure the thumbnail dir exists, so I dont need to be checking it over and over on self.getThumb()
        try:
            if not os.path.exists(thdir):
                os.mkdir(thdir)
        except:
            thdir = sys.path[0] + os.sep 
        return thdir
    
    def __set_properties(self):
        # begin wxGlade: MainFrame.__set_properties
        self.SetTitle(_("imgSeekLite"))
        _icon = wxEmptyIcon()
        _icon.CopyFromBitmap(wxBitmap(_(self.imgseekdatadir+"imgSeekLite.ico"), wxBITMAP_TYPE_ANY))
        self.SetIcon(_icon)
        self.SetSize((872, 718))
        self.mStatusBar.SetStatusWidths([-1, -1])
        # statusbar fields
        mStatusBar_fields = [_("Empty collection"), _("Ready.")]
        for i in range(len(mStatusBar_fields)):
            self.mStatusBar.SetStatusText(mStatusBar_fields[i], i)
        self.thumbList.SetBackgroundColour(wxColour(0, 0, 0))
        self.thumbList.SetForegroundColour(wxColour(255, 255, 255))
        self.thumbList.SetToolTipString(_("Left-click to search for similar images. Right-click to show image."))
        self.dirTree.SetToolTipString(_("Select a directory and choose an action"))
        self.recursiveCheck.SetValue(1)
        self.addDirBtn.SetSize(self.addDirBtn.GetBestSize())
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MainFrame.__do_layout
        sizer_1 = wxBoxSizer(wxVERTICAL)
        sizer_2 = wxFlexGridSizer(1, 2, 0, 0)
        sizer_3 = wxBoxSizer(wxVERTICAL)
        sizer_4 = wxStaticBoxSizer(wxStaticBox(self.browsePane, -1, _("Add")), wxVERTICAL)
        sizer_5 = wxBoxSizer(wxHORIZONTAL)
        sizer_5.Add(self.thumbList, 1, wxEXPAND, 0)
        self.searchPane.SetAutoLayout(1)
        self.searchPane.SetSizer(sizer_5)
        sizer_5.Fit(self.searchPane)
        sizer_5.SetSizeHints(self.searchPane)
        sizer_2.Add(self.dirTree, 1, wxEXPAND, 0)
        sizer_4.Add(self.recursiveCheck, 0, 0, 0)
        sizer_4.Add(self.addDirBtn, 0, wxALL|wxEXPAND|wxALIGN_BOTTOM|wxALIGN_CENTER_HORIZONTAL, 0)
        sizer_3.Add(sizer_4, 1, wxALL|wxALIGN_RIGHT, 0)
        sizer_2.Add(sizer_3, 1, 0, 0)
        self.browsePane.SetAutoLayout(1)
        self.browsePane.SetSizer(sizer_2)
        sizer_2.Fit(self.browsePane)
        sizer_2.SetSizeHints(self.browsePane)
        sizer_2.AddGrowableRow(0)
        sizer_2.AddGrowableCol(0)
        self.mNotebook.AddPage(self.searchPane, _("Search"))
        self.mNotebook.AddPage(self.browsePane, _("Populate"))
        sizer_1.Add(wxNotebookSizer(self.mNotebook), 1, wxEXPAND, 0)
        self.SetAutoLayout(1)
        self.SetSizer(sizer_1)
        self.Layout()
        # end wxGlade

    def updateStatus(self):
        imgC = self.imgdb.getImgCount()        
        self.mStatusBar.SetStatusText(_("Ready"),1)
        self.mStatusBar.SetStatusText(_("Collection: %d image(s)"% imgC),0)
        
    def onAddDir(self,evt):
        self.mStatusBar.SetStatusText(_("Adding..."),1)
        added = self.imgdb.addDir(self.dirTree.GetPath(), recurse = self.recursiveCheck.IsChecked(),yieldFcn = self.mainApp.Yield)
        self.mStatusBar.SetStatusText(_("Ready"),1)
        self.mStatusBar.SetStatusText(_("%d image(s) added"% added),0)
        self.populateThumbRandom(20)
        self.updateStatus()
        
    def getThumb(self,id):
        thname = self.imgdb.getThumbPath(id)
        nB = None
        import os
        
        if not os.path.exists(thname):
            nImg = wxImage(self.imgdb.getImgPath(id))
            if os.name in ["nt","dos"]: # temporario. wxMSW nao tah funcionando isso pq wxImageList nao pode ter tamanho fixo de 128x128                    
                nImg.Rescale(128,128)
            else:
                if (nImg.GetWidth() > nImg.GetHeight()):
                    nImg.Rescale(128,int((128*nImg.GetHeight())/nImg.GetWidth()))
                else:
                    nImg.Rescale(int((128*nImg.GetWidth())/nImg.GetHeight()),128)
            nB = nImg.ConvertToBitmap()
            del nImg            
        else:
            nB = wxBitmap(thname)
        return nB

    def populateThumbIDs(self,idlist):
        flist = []
        for id in idlist:
            flist.append([self.getThumb(id),os.path.split(self.imgdb.getImgPath(id))[-1],id ])
        return self.populateThumb(flist)
    
    def populateThumb(self, idlist):
        #idlist is list of pairs [ wxBitmap,label,data(id) ]
        self.thumbList.ClearAll()
        self.il = wxImageList(128,128)

        self.thumbList.SetImageList(self.il, wxIMAGE_LIST_NORMAL)

        cnt = 0
        
        for id in idlist:
            cnt += 1
            newItem = wxListItem()
            ix = self.il.Add(id[0])
            newItem.m_mask = wxLIST_MASK_IMAGE | wxLIST_MASK_DATA | wxLIST_MASK_TEXT
            newItem.SetImage(ix)
            newItem.SetText(id[1])
            newItem.SetData(id[2])

            self.thumbList.InsertItem(newItem)

    def populateThumbRandom(self, cnt):
        idlist = []
        if type(cnt) != int:
            cnt = 20
        for i in range(cnt):
            idlist.append(self.imgdb.getRandomID())
        
        self.populateThumbIDs(filter(None,idlist))

    def onThumbActivated(self,e):
        id = e.GetData()
        fname = self.imgdb.getImgPath(id)
        smfname = os.path.split(fname)[-1]
        
        if not self.mPreviewDlg:
            self.mPreviewDlg = previewDlg(self,wxNewId(),smfname)
            self.previewBmpCtrl = wxStaticBitmap( self.mPreviewDlg.previewPanel  ,-1, wxBitmap(fname))
            
        self.mPreviewDlg.Show()
        nBmp = wxBitmap(fname)
        self.previewBmpCtrl.SetBitmap( nBmp )
        self.mPreviewDlg.previewPanel.SetScrollbars(20, 20, nBmp.GetWidth()/20+2, nBmp.GetHeight()/20+2)
        self.mPreviewDlg.previewPanel.Update()
        self.mPreviewDlg.infoLabel.SetLabel(fname)
        
    def onThumbSelected(self,e):        
        id = e.GetData()
        res = self.imgdb.queryId(id)
        flist = []
        if os.name in ["nt","dos"]:     # wxPython from win seems to invert this.....
            res.reverse()        
        for imgp in res:
            flist.append([self.getThumb(imgp[0]), "%.2f %%"%imgp[1] ,imgp[0] ])
        self.populateThumb(flist)

    def onNewDB(self,e):
        nf = wxFileSelector(_("Choose a new database file"),default_extension="db",wildcard="*.img", flags=wxSAVE)
        self.imgdb.openMetaDB(nf)
        self.updateStatus()
        self.populateThumbRandom(20)
        
    def onSaveDB(self,e):
        self.imgdb.saveMetaDB()
        
    def onOpenDB(self,e):
        nf = wxFileSelector(_("Choose a database file to open"),default_extension="db",wildcard="*.img", flags=wxOPEN)
        self.imgdb.openMetaDB(nf)
        self.updateStatus()
        self.populateThumbRandom(20)
        
    def onExitMenu(self,e):
        self.Close()

    def onAboutMenu(self,e):
        wxMessageBox(\
"""
imgSeekLite version %s

For copyright info see the COPYING file included in the distribution.

Site:
http://imgseek.sourceforge.net/lite/

Author:
Ricardo Niederberger Cabral
<nieder@mail.ru>
"""%str(__version__),  "About imgSeekLite",  style = wxOK | wxCENTRE|wxICON_INFORMATION)
        
        
    def onShowSketch(self,e):
        if not self.mSketchDlg:
            self.mSketchDlg = sketchDialog( self,wxNewId() , self.imgseekdatadir)
        self.mSketchDlg.Show()
        self.mSketchDlg.queryFcn = self.queryImage
        
    def queryImage(self,img,numres=20):
        sig = self.imgdb.calcSig(img)
        assert(sig)
        res = self.imgdb.querySig(sig,numres)        
        flist = []
        if os.name in ["nt","dos"]:     # wxPython from win seems to invert this.....
            res.reverse()
        for imgp in res:
            flist.append([self.getThumb(imgp[0]), "%.2f %%"%imgp[1] ,imgp[0] ])
        self.populateThumb(flist)

# end of class MainFrame


