# generated by wxGlade 0.3 on Sun Aug 31 11:24:14 2003

from wxPython.wx import *
from doodleWidget import DoodleWindow

# begin wxGlade: dependencies
# end wxGlade

class sketchDialog(wxDialog):
    def __init__(self, *args, **kwds):
        self.imgseekdatadir = args[2]
        # begin wxGlade: sketchDialog.__init__
        kwds["style"] = wxDEFAULT_DIALOG_STYLE
        wxDialog.__init__(self, *args, **kwds)
        self.sketchWnd = DoodleWindow(self, -1)
        self.realtimeCheck = wxCheckBox(self, -1, _("Query in realtime"))
        self.sketchQueryBtn = wxButton(self, -1, _("Query"))
        self.eraseBtn = wxButton(self, -1, _("Erase"))

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

        ### Members
        self.queryFcn = None
        self.sketchWnd.moveCallback = self.onSketch
        ### Events
        EVT_BUTTON (self, self.sketchQueryBtn.GetId(), self.onQuery)
        EVT_BUTTON (self, self.eraseBtn.GetId(), self.onErase)        

    def __set_properties(self):
        # begin wxGlade: sketchDialog.__set_properties
        self.SetTitle(_("Query sketch"))
        self.SetToolTipString(_("Right-click drawing area for more options"))
        self.realtimeCheck.SetValue(1)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: sketchDialog.__do_layout
        grid_sizer_2 = wxFlexGridSizer(2, 1, 0, 0)
        sizer_6 = wxGridSizer(1, 3, 0, 0)
        grid_sizer_2.Add(self.sketchWnd, 1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0)
        sizer_6.Add(self.realtimeCheck, 0, wxEXPAND, 0)
        sizer_6.Add(self.sketchQueryBtn, 0, 0, 0)
        sizer_6.Add(self.eraseBtn, 0, 0, 0)
        grid_sizer_2.Add(sizer_6, 1, wxEXPAND, 0)
        self.SetAutoLayout(1)
        self.SetSizer(grid_sizer_2)
        grid_sizer_2.Fit(self)
        grid_sizer_2.SetSizeHints(self)
        grid_sizer_2.AddGrowableRow(0)
        grid_sizer_2.AddGrowableRow(1)
        grid_sizer_2.AddGrowableCol(0)
        self.Layout()
        # end wxGlade

    def onQuery(self,e):
        skFile = "sketch.png"
        try:
            self.sketchWnd.buffer.SaveFile(skFile, wxBITMAP_TYPE_PNG)
        except:
            skFile = "/tmp/sketch.png"
            self.sketchWnd.buffer.SaveFile(skFile, wxBITMAP_TYPE_PNG)            
        assert(self.queryFcn)
        self.queryFcn(skFile)
        
    def onErase(self,e):
        #self.sketchWnd.buffer = wxEmptyBitmap(256,256)
        dc = wxBufferedDC(wxClientDC(self.sketchWnd), self.sketchWnd.buffer)
        dc.BeginDrawing()
        dc.SetPen(self.sketchWnd.pen)
        dc.Clear()
        dc.EndDrawing()        
        self.sketchWnd.Refresh()

    def onSketch(self):
        if self.realtimeCheck.IsChecked():
            self.onQuery(None)            
        
# end of class sketchDialog


